]> git.xonotic.org Git - xonotic/xonotic.git/blobdiff - misc/tools/xonotic-map-compiler-autobuild
also make a foo-full-HASH.pk3 when building a map that also contains files of the...
[xonotic/xonotic.git] / misc / tools / xonotic-map-compiler-autobuild
index a22dceb4a98e3fb78401395253b6e8493752631a..90a012325b829c864083833b20f87292821e07db 100755 (executable)
@@ -1,11 +1,12 @@
 #!/bin/sh
 
-set -ex
+set -e
 
-bspdir="$PWD/bspfiles"
-url=http://141.2.16.23/~xonotic/bsp-autobuilds/
-
-bspoutdir="$HOME/public_html/bsp-autobuilds/"
+bspdir="$PWD/data"
+url=http://beta.xonotic.org/autobuild-bsp/
+url_ssh=xonotic-beta:autobuild-bsp/
+cachedir="$HOME/xonotic-map-compiler.cache/"
+override="-bsp_timeout 900 -vis_timeout 3600 -light_timeout 14400 -minimap_timeout 900 -scale_timeout 900"
 
 allmaps()
 {
@@ -23,59 +24,187 @@ allmaps()
        done
 }
 
+pre2spam()
+{
+       map=$1
+       url=$2
+       branch=$3
+       hash=$4
+
+       branch=${branch##refs/heads/}
+       branch=${branch##refs/remotes/}
+       branch=${branch##origin/}
+       hash=`echo "$hash" | cut -c 1-7`
+
+       echo "[$branch $hash] starting map compile of $map"
+}
+
+log2spam()
+{
+       map=$1
+       url=$2
+       branch=$3
+       hash=$4
+       status=$5
+       time=$6
+
+       hash=`echo "$hash" | cut -c 1-7`
+
+       branch=${branch##refs/heads/}
+       branch=${branch##refs/remotes/}
+       branch=${branch##origin/}
+
+       s_samplesize=
+       s_failshaders=
+       s_leaked=
+       s_error=
+
+       if [ "$status" -ne 0 ]; then
+               s_error="exited with status $status"
+       fi
+       while IFS= read -r L; do
+               case "$L" in
+                       WARNING:\ surface\ at\ *\ too\ large\ for\ desired\ samplesize*)
+                               s=${L##* }
+                               if [ -z "$s_samplesize" ] || [ "$s" -gt "$s_samplesize" ]; then
+                                       s_samplesize=$s
+                               fi
+                               ;;
+                       WARNING:\ Couldn\'t\ find\ image\ for\ shader\ textures/NULL)
+                               # radiant stupid
+                               ;;
+                       WARNING:\ Couldn\'t\ find\ image\ for\ shader\ *)
+                               s_failshaders="$s_failshaders ${L##* }"
+                               ;;
+                       '******* leaked *******')
+                               s_leaked=1
+                               ;;
+                       '************ ERROR ************')
+                               IFS= read -r s_error
+                               ;;
+               esac
+       done
+       s_failshaders=`echo "$s_failshaders" | sed "s, textures/, ,g"`
+       s_failshaders=${s_failshaders# }
+       if [ -n "$s_error" ]; then
+               echo -n "[$branch $hash] \ 34failed"
+       else
+               echo -n "[$branch $hash] finished"
+       fi
+       echo -n " map compile of $map ($url): $time sec"
+       if [ -n "$s_samplesize" ]; then
+               echo -n ", FIX samplesize >= $s_samplesize"
+       fi
+       if [ -n "$s_failshaders" ]; then
+               if [ -n "`echo "$s_failshaders" | cut -d ' ' -f 4-`" ]; then
+                       s_failshaders="`echo "$s_failshaders" | cut -d ' ' -f 1-3`..."
+               fi
+               echo -n ", FIX shaders $s_failshaders"
+       fi
+       if [ -n "$s_leaked" ]; then
+               echo -n ", FIX LEAK"
+       fi
+       if [ -n "$s_error" ]; then
+               s_error=`echo "$s_error" | sed "s,$PWD/\?,,g"`
+               echo -n ", ERROR: $s_error"
+       fi
+       echo
+}
+
 buildthemap()
 {
-       bspdir=$1
-       M=$2
-       blobhash=$3
-       if [ -f "$bspdir/$M-$blobhash.pk3" ]; then
+       REFNAME=$1
+       HASH=$2
+       url=$3
+       M=$4
+       blobhash=$5
+       if HEAD "$url$M-$blobhash.pk3"; then
                continue
        fi
+       if [ -n "$IRCSPAM" ]; then
+               pre2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$HASH" | $IRCSPAM
+       fi
+       t0=`date +%s`
        (
                cd maps
-               ../../../misc/tools/xonotic-map-compiler "$M" -noshaderlist `head -n 1 "$M.map.options"` 2>&1 | tee "$M.log"
+               ../../../misc/tools/xonotic-map-compiler "$M" `grep ^- "$M.map.options" | cut -d '#' -f 1` $override > "$M.log"
        )
-       zip -9r "$bspdir/$M-$blobhash.pk3" "maps/$M.bsp" "maps/$M.log" "maps/$M/" "maps/$M.lin" "gfx/${M}_mini.tga"
-       ln -snf "../$M-$blobhash.pk3" "$bspdir/latest/$M.pk3" # from ALL branches, so beware!
+       t1=`date +%s`
+       dt=$(($t1 - $t0))
+       status=$?
+       if [ -n "$IRCSPAM" ]; then
+               cat "maps/$M.log" | log2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$HASH" "$status" "$dt" > "maps/$M.irc"
+       fi
+       zip -9r "$M-$blobhash.pk3" "maps/$M.bsp" "maps/$M.log" "maps/$M.irc" "maps/$M/" "maps/$M.lin" "gfx/${M}_mini.tga"
+       ln -snf "../$M-$blobhash.pk3" "$M.pk3" # from ALL branches, so beware!
+       cp "$M-$blobhash.pk3" "$M-full-$blobhash.pk3"
+       zip -9r "$M-full-$blobhash.pk3" `git diff --name-only --diff-filter=ACMRTUXB master...HEAD` || true
+       ln -snf "../$M-full-$blobhash.pk3" "$M-full.pk3" # from ALL branches, so beware!
+       rsync -vaSHP "$M-$blobhash.pk3" "$M-full-$blobhash.pk3" "$url_ssh"
+       rsync -vaSHP "$M.pk3" "$M-full.pk3" "$url_ssh""latest/"
+       if [ -n "$IRCSPAM" ]; then
+               $IRCSPAM < "maps/$M.irc"
+       fi
 }
 
 getthemap()
 {
        url=$1
-       bspdir=$2
-       M=$3
-       blobhash=$4
-       if [ -f "$bspdir/$M-$blobhash.pk3" ]; then
+       bspdir_old=$2
+       bspdir=$3
+       M=$4
+       blobhash=$5
+       if mv "$bspdir_old/$M-$blobhash.pk3" "$bspdir/$M-$blobhash.pk3"; then
                continue
        fi
        if ! wget -O "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
-               rm -f "$bspdir/$M-$blobhash.pk3"
-               echo "WARNING: could not download $url$M-$blobhash.pk3, maybe not ready yet"
-               return 1
+               if ! curl -o "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
+                       rm -f "$bspdir/$M-$blobhash.pk3"
+                       echo "WARNING: could not download $url$M-$blobhash.pk3, maybe not ready yet"
+                       return 0
+               fi
        fi
        if ! unzip -l "$bspdir/$M-$blobhash.pk3"; then
                rm -f "$bspdir/$M-$blobhash.pk3"
                echo "WARNING: could not download $url$M-$blobhash.pk3, invalid zip file"
-               return 1
+               return 0
        fi
 }
 
 case "$1" in
        build)
-               mkdir -p "$bspoutdir"
-               mkdir -p "$bspoutdir/latest"
                cd data/xonotic-maps.pk3dir
                git for-each-ref 'refs/remotes' | while read -r HASH TYPE REFNAME; do
+                       if [ -f "$cachedir/$HASH" ]; then
+                               continue
+                       fi
                        git reset --hard
                        git clean -xfd
-                       git checkout "$HASH"
-                       allmaps buildthemap "$bspoutdir"
+                       git checkout -f "$HASH"
+                       allmaps buildthemap "$REFNAME" "$HASH" "$url"
+                       touch "$cachedir/$HASH"
                done
-               git checkout master
+               git checkout -f master
                ;;
        download)
-               mkdir -p "$bspdir"
+               mkdir -p "$bspdir" "$bspdir.old"
+               for b in "$bspdir"/*-????????????????????????????????????????-????????????????????????????????????????.pk3; do
+                       if [ -e "$b" ]; then
+                               mv "$b" "$bspdir.old"/
+                       fi
+               done
                cd data/xonotic-maps.pk3dir
-               allmaps getthemap "$url" "$bspdir"
+               allmaps getthemap "$url" "$bspdir.old" "$bspdir"
+               echo "List of maps that got deleted (if any) and currently are in $bspdir.old:"
+               ls -l "$bspdir.old"
+               ;;
+       download-latest)
+               mkdir -p "$bspdir"
+               cd "$bspdir"
+               rm -f *-????????????????????????????????????????-????????????????????????????????????????.pk3
+               wget -r -l1 -A "*.pk3" -N --no-parent --no-directories "$url""latest"
+               ;;
+       log2spam-test)
+               log2spam "mapname" "http://mapurl" "branch" "commit" "0"
                ;;
 esac